#!/usr/bin/env ruby

$VERBOSE = true

base_dir = File.expand_path(File.join(File.dirname(__FILE__), ".."))
$:.unshift(File.join(base_dir, "test-unit", "lib"))
require 'test/unit'

$:.unshift(File.join(base_dir, "lib"))
require "rss"

$:.unshift(File.join(base_dir, "test"))

test_file = File.join(base_dir, "test", "test_*.rb")
case ARGV.first
when /\A--\z/
  ARGV.shift
when /\A-/, nil;
else
  test_file = ARGV.shift
end

Dir.glob(test_file) do |file|
  require file
end

argv = ARGV.dup
argv.unshift("--verbose=n")
argv.unshift("--priority")

RSS::AVAILABLE_PARSERS.each do |parser|
  puts "------------------------------------"
  puts "Using #{parser}"
  puts "------------------------------------"
  RSS::Parser.default_parser = parser
  break unless defined?(Test::Unit::AutoRunner)
  GC.start
  args = [File.dirname($0), argv.dup]
  if Test::Unit::AutoRunner.respond_to?(:standalone?)
    args.unshift(false)
  else
    args.unshift($0)
  end
  Test::Unit::AutoRunner.run(*args)
  puts
end
